import { useState } from "react";
/** Like react's useMemo but with guarantee that the fn
 * won't be invoked again if deps hasn't change */
export function useGuaranteedMemo(fn, deps) {
    const [ref] = useState({ "current": undefined });
    if (ref.current === undefined ||
        deps.length !== ref.current.prevDeps.length ||
        ref.current.prevDeps.find((v, i) => v !== deps[i]) !== undefined) {
        ref.current = {
            "v": fn(),
            "prevDeps": [...deps]
        };
    }
    return ref.current.v;
}
